function [y_time,t,fs, y_filtered,freq_vector]=plot_signal(file)

[y,fs] = audioread(file);

%--------------------------------------------------------------------------
%SPECTROGRAM OF THE SIGNAL
% window=rectwin(floor(5000));
% figure(1); 
% spectrogram(y,window,'yaxis');
% title('Spectrogram N=5000')
% xlabel ('Time (s*10^-1)')
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
% Filter the signal
fcl = 1100;
[A,B] = butter(6,fcl/(fs/2));
%freqz(A,B)
y_filtered = filter(A,B,y);
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
%Time Domain Plot
y_time=y_filtered; %copy of the time-domain signal
d=length(y_filtered);
dt = 1/fs;
t = 0:dt:(d*dt)-dt;
% figure(2);
% plot(t,y_filtered); xlabel('Time (Seconds)'); ylabel('Amplitude');
% title('Time domain')
%--------------------------------------------------------------------------

%--------------------------------------------------------------------------
%Frequency Domain Plot
n=d-1;  
freq_vector=(-fs/2):fs/n:(fs/2);       %Frequency vector with freq. samples
y_filtered=fft(y_filtered);
 
% figure(3);
% plot(freq_vector,abs(fftshift(y_filtered)))
% xlabel('Frequency (Hz)'); ylabel('Amplitude');
% title('Frequency domain')

%--------------------------------------------------------------------------
% %Spectrogram
% window=rectwin(floor(5000));
% figure(4); 
% spectrogram(y_time,window,'yaxis');
% title('Spectrogram N=5000')
% xlabel ('Time (s*10^-1)')
%--------------------------------------------------------------------------
end