clear all
clc

file='Piano Chromatic.m4a';
%file='Piano Melody.m4a';

if (strcmp(file,'Piano Chromatic.m4a'))
   original=[60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84]; 
else
    original = [69 73 81 80 81 69 73 81 69 76 81 69 74 69 73 74 76 73 71 69 68 69 64 69 71 73 73 74 76 74 73 71];
end

[y_time,t,fs]=plot_signal(file);

[MaxVector,vec,interval_vector] = NoteVector(y_time,t,fs);                  % MaxVector is calculated with our algorithm and vec is calculated with the AMDF
midi = round(abs(12*log2(vec/440)+49))+20;                                  % midi translates vec (AMDF vector) into midi numbers


[~,~,nn]=size( MaxVector );

load('trainedClassifier2');                                                 %KNN classifier
load('trainedClassifier3');                                                 %Complex Tree Classifier

for len=1:1:nn
PredictTable = table(MaxVector(:,1,len), MaxVector(:,2,len), 'Variablenames',{'MainFrequency' 'Harmonic'});
yfit(len) = trainedClassifier2.predictFcn(PredictTable);                    %KNN Classifier
yfit1(len) = trainedClassifier3.predictFcn(PredictTable);                   %Complex Tree Classifier
end

%view(trainedClassifier3.ClassificationTree,'Mode','graph')                 %Plot the complex tree 


note = {'c4', 'c4sharp', 'd4', 'd4sharp', 'e4', 'f4', 'f4sharp', 'g4', 'g4sharp','a4', 'a4sharp', 'b4', ...
    'c5', 'c5sharp', 'd5', 'd5sharp', 'e5', 'f5', 'f5sharp', 'g5', 'g5sharp','a5', 'a5sharp', 'b5',  'c6'};

MIDI=[60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84];

for fin=1:length(yfit)                                                      %Translate the names of the notes into MIDI values
    for fin2=1:length(MIDI)
        if (strcmp(yfit(fin),note(fin2)))
            yfit_midi(fin)=MIDI(fin2);
        end
        if (strcmp(yfit1(fin),note(fin2)))
            yfit1_midi(fin)=MIDI(fin2);
        end
    end
end

duration_input1 = [yfit_midi;interval_vector];                             % Calculate the durations of the notes 
[durations1] = durs(duration_input1);

duration_input2 = [yfit1_midi;interval_vector];
[durations2] = durs(duration_input2);

duration_input3 = [midi;interval_vector];
[durations3] = durs(duration_input3);

if (strcmp(file,'Piano Chromatic.m4a'))
    [x1] = accuracy(yfit_midi,original);
    [x2] = accuracy(yfit1_midi,original);
    [x3] = accuracy(midi,original);

    print_notes(durations1);  
    title(['KNN Classifier - Accuracy: ' num2str(x1), '%'])%Sheet Music Printing

    print_notes(durations2);
    title(['Complex Tree Classifier - Accuracy: ', num2str(x2), '%'])

    print_notes(durations3);
    title(['AMDF - Accuracy: ', num2str(x3), '%'])
else
    print_notes(durations1);                                                    %Sheet Music Printing
    title('KNN Classifier')
    print_notes( durations2);
    title('Complex Tree Classifier')
    print_notes(durations3);
    title('AMDF')
end



[y,fs]=audioread(file);
sound(y,fs);
